if not Doodlepad then _G.Doodlepad = {} end
local libmg = LibStub("LibMouseGestures-1.0");
local doodle = libmg:New(UIParent);
local colors = {{1,0,0,1},{0,1,0,1},{0,0,1,1},{1,1,0,1},{1,0,1,1},{0,1,1,1},{1,0.5,0,1},{0,0,0,1}}
local color = colors[1];
local colorx = 1;
local nodoodling = true;
local bases = { '0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z' };
local otherdoodles = {};
local dw,dh = 480, 320; -- default width/height. Used for the uniform coordinate system.
local penWidth = 80; -- default pen size.
local myName = UnitName("player");

function rebase(number, from, to)
	local num = tonumber(number, from) or 0;
	local y,retval,rem = to - 1,"",num;
	while ( num > y ) do local x = math.floor(num/to); rem = num - (x*to); num = x;retval = (bases[rem+1] or 0) .. (retval or 0);end
	retval = (bases[num+1] or 0) .. ( retval or 0);
	return retval;
end

function Doodlepad_window(chan, uid)
    local frame = CreateFrame("Frame", nil, UIParent);
    frame:SetBackdrop({bgFile = "Interface/GLUES/loading",edgeFile = "Interface/GLUES/Common/TextPanel-Border",edgeSize = 16,insets = { left = 4, right = 4, top = 4, bottom = 4 }});
    frame:SetBackdropColor(1,1,1,0.4);
    frame:SetWidth(dw)
    frame:SetHeight(dh);
    frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
	frame:RegisterForDrag("LeftButton");
	frame:SetScript("OnDragStart",function()  frame:StartMoving(); end);
	frame:SetScript("OnDragStop", function()  frame:StopMovingOrSizing(); end);
	frame:SetMovable(true);
	frame:EnableMouse(true);
	frame:EnableMouseWheel(true);
	frame:SetResizable(true);
	local subFrame = CreateFrame("Frame");
	subFrame:SetParent(frame);
	subFrame:SetPoint("TOPLEFT", 5, -28);
	subFrame:SetPoint("BOTTOMRIGHT", -5, 15);
	local canvas = subFrame:CreateTexture("ARTWORK");
	canvas:SetTexture(1,1,1,0.85);
	canvas:SetAllPoints(subFrame);
	local recorder = libmg:New(subFrame);
	local xframe = frame;


	-- caption
	local caption = frame:CreateFontString(nil, "DIALOG");
	caption:SetParent(frame);
	caption:SetFontObject(ChatFontNormal);
	caption:SetText("Doodlepad");
	caption:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -5);
	caption:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", 5, -25);
	recorder.caption = caption;

    -- close button
    local close = CreateFrame("button", nil, frame, "UIPanelCloseButton");
    close:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 0);
    close:Show();
	close:SetScript("OnClick",
		function()
		frame:Hide();
		Doodle_Draw(recorder, true); -- wipe the pad
		print("Doodlepad closed. The doodle has been saved for any later use you might have for it.");
		tinsert(Doodlepad, {uid = recorder.uid, sender = recorder.sender or UnitName("player"), doodle = recorder.doodles});
		end);

	-- resizer
    local sizer = CreateFrame("frame", nil, frame);
    sizer:SetPoint("BOTTOMRIGHT")
    sizer:SetHeight(15);
    sizer:SetWidth(15);
    sizer:EnableMouse()
    sizer:SetScript("OnMouseDown",function(frame) frame:GetParent():StartSizing("BOTTOMRIGHT") end)
    sizer:SetScript("OnMouseUp", function(frame) frame:GetParent():StopMovingOrSizing() recorder.width = xframe:GetWidth(); recorder.height = xframe:GetHeight(); Doodle_Redraw(recorder); end)

    local line1 = sizer:CreateTexture(nil, "BACKGROUND")
    line1:SetWidth(14)
    line1:SetHeight(14)
    line1:SetPoint("BOTTOMRIGHT", 0, 0)
    line1:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
    local x = 0.1 * 14/17
    line1:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)

    local line2 = sizer:CreateTexture(nil, "BACKGROUND")
    line2:SetWidth(8)
    line2:SetHeight(8)
    line2:SetPoint("BOTTOMRIGHT", 0,0)
    line2:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
    local x = 0.1 * 8/17
    line2:SetTexCoord(0.05 - x, 0.5, 0.05, 0.5 + x, 0.05, 0.5 - x, 0.5 + x, 0.5)



	recorder.width, recorder.height = dw,dh;
	recorder.doodles, recorder.cdoodle, recorder.texs, recorder.free, recorder.icon, recorder.color = {},{creator=myName},{},{}, 1, 1;
	recorder.target = recorder.drawLayer:CreateTexture("OVERLAY",7);
	recorder.target:SetTexture([[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_]] .. recorder.icon);
	recorder.target:SetWidth(32);
	recorder.target:SetHeight(32);

	frame:SetScript("OnMouseWheel",
		function(caller, value)
			if ( IsControlKeyDown() ) then
				recorder.icon = recorder.icon + value;
				if ( recorder.icon > 8 ) then recorder.icon = 1; end
				if ( recorder.icon < 1 ) then recorder.icon = 8; end
			else
				recorder.color = recorder.color + value;
				if ( recorder.color > #colors ) then recorder.color = 1; end
				if ( recorder.color < 1 ) then recorder.color = #colors; end
			end
		end);
	subFrame:SetScript("OnUpdate",
		function()
			if ( subFrame:IsMouseOver() ) then
				if ( IsControlKeyDown() ) then
					recorder.target:SetTexture([[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_]] .. recorder.icon);
					recorder.target:SetWidth(32);
					recorder.target:SetHeight(32);
					recorder.target:SetPoint("TOPLEFT", recorder.mouseEnd[1]-16, -recorder.mouseEnd[2]+16);
					recorder.target:Show();
				else
					recorder.target:SetTexture(unpack(colors[recorder.color or 1]));
					recorder.target:SetWidth(4);
					recorder.target:SetHeight(4);
					recorder.target:SetPoint("TOPLEFT", recorder.mouseEnd[1]-2, -recorder.mouseEnd[2]+2);
					recorder.target:Show();
				end
			else
				recorder.target:Hide();
			end
		end);
	recorder:StartCapture({
		startButton		= "LeftButtonDown",
		stopButton		= "LeftButtonUp",
		cancelButton    = "RightButtonUp",
		startFunc 		= Doodle_Color,
		updateFunc		= Doodle_Update,
		stopFunc 		= Doodle_Stop,
		cancelFunc		= Doodle_Cancel,
	});
	if ( type(uid) == "string" ) then recorder.uid = uid; frame:Hide(); end
	chan = string.lower(chan or "");
	if ( chan == "raid" or chan == "party" or chan == "guild" ) then
		recorder.chan = chan;
		recorder.uid = ("%08x%08x"):format(math.random(time()), math.random(GetTime()));
		print("Sharing doodle with the " .. chan);
	elseif ( chan:len() > 0 ) then
		recorder.chan = chan;
		recorder.uid = ("%08x%08x"):format(math.random(time()), math.random(GetTime()));
		print("Sharing doodle with " .. chan);
	end
	return frame, recorder;
end




function Doodle_DrawLine(rec, T, sx, sy, ex, ey, col)
	sx = sx * (rec.width/dw);
	sy = sy * (rec.height/dh);
	ex = ex * (rec.width/dw);
	ey = ey * (rec.height/dh);
	T:SetTexCoord(0,1,0,1);
	local color = col or color;
    sy = -sy;
    ey = -ey;
	local C = rec.drawLayer;
    w = penWidth;
    local dx,dy = ex - sx, ey - sy;
    local cx,cy = (sx + ex) / 2, (sy + ey) / 2;
    if (dx < 0) then
        dx,dy = -dx,-dy;
    end
    local Z = (256/255) / 2;
    local l = sqrt((dx * dx) + (dy * dy));
    local s,c = -dy / l, dx / l;
    local sc = s * c;
    local Bwid, Bhgt, BLx, BLy, TLx, TLy, TRx, TRy, BRx, BRy;
    if (dy >= 0) then
        Bwid = ((l * c) - (w * s)) * Z;
        Bhgt = ((w * c) - (l * s)) * Z;
        BLx, BLy, BRy = (w / l) * sc, s * s, (l / w) * sc;
        BRx, TLx, TLy, TRx = 1 - BLy, BLy, 1 - BRy, 1 - BLx;
        TRy = BRx;
    else
        Bwid = ((l * c) + (w * s)) * Z;
        Bhgt = ((w * c) + (l * s)) * Z;
        BLx, BLy, BRx = s * s, -(l / w) * sc, 1 + (w / l) * sc;
        BRy, TLx, TLy, TRy = BLx, 1 - BRx, 1 - BLx, 1 - BLy;
        TRx = TLy;
    end
    T:SetDrawLayer("BACKGROUND", 3)
	T:ClearAllPoints();
	if (tonumber(tostringall(Bwid)) == nil or tonumber(tostringall(Bhgt)) == nil) then return; end -- discard bad data (#IND or #INF)
    T:SetVertexColor(color[1],color[2],color[3],color[4]);
    T:SetTexCoord(TLx, TLy, BLx, BLy, TRx, TRy, BRx, BRy);
    T:SetPoint("TOPLEFT",   C, "TOPLEFT", cx - Bwid, cy + Bhgt);
    T:SetWidth(Bwid*2);
    T:SetHeight(Bhgt*2);
    T:Show()
end

function Doodlepad_Incoming(prefix,msg,chan,sender)
	if ( prefix == "DPD" ) then
		local uid, typ, col, data = msg:sub(1,16), msg:sub(17,17), msg:sub(18,18), msg:sub(19);
		local Color = colors[tonumber(col) or 1] or colors[1];
		local found = false;
		local rec = nil;
		for n = 1, #otherdoodles do
			if ( otherdoodles[n].uid == uid ) then
				found = true;
				rec = otherdoodles[n].recorder;
				break;
			end
		end
		if ( not found ) then
			local frame, recorder = Doodlepad_window(chan, uid);
			recorder.caption:SetText("Doodlepad - Broadcast by " .. sender);
			table.insert(otherdoodles, { frame = frame, recorder = recorder, uid = uid, sender = sender} );
			rec = recorder;
			rec.sender = sender;
			rec.painters = {sender};
			rec.uid = uid;
			if ( chan == "WHISPER" ) then chan = sender; end
			rec.chan = chan;
			print(string.format("Doodlepad: %s is broadcasting a doodle. |HDPD:%s|h|cFFFFFF00[Click here]|r|h to view it",sender, uid));
		end
		if ( rec ) then
			local allowed = false;
			if ( sender == rec.sender ) then allowed = true; end
			if ( chan == "RAID" and not allowed ) then
				for n = 1, 25 do
					name, rank, _ = GetRaidRosterInfo(n);
					if ( name == sender ) then
						if ( rank > 0 ) then
							allowed = true;
							local found = false;
							for i = 1, #rec.painters do
								if ( rec.painters[n] == sender ) then found = true; break; end
							end
							if ( not found ) then
								print( ("Doodlepad: %s has joined %s's doodle session"):format(sender, rec.sender));
								tinsert(rec.painters, sender);
							end
							break;
						end
					end
				end
			end
			if ( (allowed and sender ~= UnitName("player")) or rec.chan == UnitName("player") ) then
				if ( #rec.cdoodle > 0 ) then
					table.insert(rec.doodles, rec.cdoodle);
					rec.cdoodle = {creator=sender};
				end
				if ( typ == "D" ) then -- drawings
					rec.cdoodle.creator = sender;
					rec.cdoodle.color = Color;
					for n = 1, math.floor(data:len()/5) do
						local p = ((n-1)*5)+1;
						local x, y, z = rebase(data:sub(p, p+1), 32, 10), rebase(data:sub(p+2, p+3), 32, 10), data:sub(p+4, p+4);
						table.insert(rec.cdoodle, {x,y,nil,z});
						Doodle_Draw(rec, false, Color);
					end
					table.insert(rec.doodles, rec.cdoodle);
					rec.cdoodle = {creator=sender};
				elseif ( typ == "U" ) then Doodlepad_Undo(rec, sender);
				elseif ( typ == "W" ) then Doodlepad_Undo(rec, sender, true);
				end
			end
		end
	end
end



function Doodle_ParseLink(link, text, button, chatframe)
	local linktype, id = strsplit(":", link)
	if linktype == "DPD" then
		local uid = id;
		for n = 1, #otherdoodles do
			if ( otherdoodles[n].uid == uid ) then
				otherdoodles[n].frame:Show();
				break;
			end
		end
	else
		doodle.itemref(link, text, button, chatframe);
	end
end


function Doodle_Update(rec,a,b,c,d)
	if ( #rec.cdoodle > 0 ) then
		local l = rec.cdoodle[#rec.cdoodle];
		if ( math.floor(l[1]) ~= math.floor(c) or math.floor(l[2]) ~= math.floor(d) ) then
			if ( abs( l[1] - c) < 1 and abs(l[2] - d) < 1 ) then -- lines that don't go anywhere makes me a sad panda.
				return;
			end
			local dist = math.sqrt( math.pow(l[1] - c, 2) + math.pow(l[2] - d, 2));
			if ( dist > 3 ) then -- Any lines shorter than 3 pixels get discarded.
				c = c * (dw/rec.width);
				d = d * (dh/rec.height);
				table.insert(rec.cdoodle, {c,d,nil,0});
			end
		end
	else
		c = c * (dw/rec.width);
		d = d * (dh/rec.height);
		table.insert(rec.cdoodle, {c,d,nil,0});
	end
	Doodle_Draw(rec, nil, rec.cdoodle.color);
end

function Doodle_Color(rec)
	rec.cdoodle.color = colors[rec.color];
end

function Doodle_Stop(rec,a,b,c,d)
	if ( IsControlKeyDown() ) then
		table.insert(rec.cdoodle, {c*(dw/rec.width),d*(dh/rec.height), nil, rec.icon or 1});
		Doodle_Draw(rec);
	end

	table.insert(rec.doodles, rec.cdoodle);
	rec:StartCapture({
		startButton		= "LeftButtonDown",
		stopButton		= "LeftButtonUp",
		cancelButton    = "RightButtonUp",
		startFunc 		= Doodle_Color,
		updateFunc		= Doodle_Update,
		stopFunc 		= Doodle_Stop,
		cancelFunc		= Doodle_Cancel,
	});
	local s = 0;
	for b = 1, #rec.cdoodle do
		s = s + 4;
	end
	if ( rec.chan and (#rec.cdoodle > 1 or (rec.cdoodle[1] and rec.cdoodle[1][4] ~= 0)) ) then
		local x = 0;
		local c = "";
		for n = 1, #rec.cdoodle do
			x = x + 1;
			c = c .. ("%2s%2s%1u"):format(rebase(math.floor(rec.cdoodle[n][1]), 10, 32), rebase(math.floor(rec.cdoodle[n][2]), 10, 32), rec.cdoodle[n][4] or 0);
			if ( x > 40 ) then
				if ( rec.chan == "raid" or rec.chan == "guild" or rec.chan == "party" ) then
					SendAddonMessage("DPD",rec.uid .. "D" .. rec.color .. c, rec.chan);
				else
					SendAddonMessage("DPD",rec.uid .. "D" .. rec.color .. c, "WHISPER", rec.chan);
				end
				c = ("%2s%2s%1u"):format(rebase(math.floor(rec.cdoodle[n][1]), 10, 32), rebase(math.floor(rec.cdoodle[n][2]), 10, 32), rec.cdoodle[n][4] or 0);
				x = 0;
			end
		end
		if ( c:len() > 0 ) then
			if ( rec.chan == "raid" or rec.chan == "guild" or rec.chan == "party" ) then
				SendAddonMessage("DPD",rec.uid .. "D" .. rec.color .. c, rec.chan);
			else
				SendAddonMessage("DPD",rec.uid .. "D" .. rec.color .. c, "WHISPER", rec.chan);
			end
		end
	end
	rec.cdoodle = {creator=myName};
end

function Doodlepad_Undo(rec, author, wipe)
	for n = #rec.doodles, 1, -1 do
		local doodle = rec.doodles[#rec.doodles];
		if ( doodle and doodle.creator == author ) then
			if not wipe then tremove(doodle);
			else doodle = {}; end
			if ( #doodle == 0 ) then
				tremove(rec.doodles, n);
			end
			Doodle_Redraw(rec);
			if not wipe then break end
		end
	end
end

function Doodle_Cancel(rec)
	if ( IsShiftKeyDown() ) then
		Doodlepad_Undo(rec, myName, true);
		if ( rec.chan ) then
			if ( rec.chan == "raid" or rec.chan == "guild" or rec.chan == "party" ) then
				SendAddonMessage("DPD",rec.uid .. "W", rec.chan);
			else
				SendAddonMessage("DPD",rec.uid .. "W", "WHISPER", rec.chan);
			end
		end
		rec.cdoodle = {creator=myName};
	else
		Doodlepad_Undo(rec, myName);
		if ( rec.chan ) then
			if ( rec.chan == "raid" or rec.chan == "guild" or rec.chan == "party" ) then
				SendAddonMessage("DPD",rec.uid .. "U", rec.chan);
			else
				SendAddonMessage("DPD",rec.uid .. "U", "WHISPER", rec.chan);
			end
		end
	end
	rec:StartCapture({
		startButton		= "LeftButtonDown",
		stopButton		= "LeftButtonUp",
		cancelButton    = "RightButtonUp",
		startFunc 		= Doodle_Color,
		updateFunc		= Doodle_Update,
		stopFunc 		= Doodle_Stop,
		cancelFunc		= Doodle_Cancel,
	});
end

function Doodle_Draw_Point(rec, pointa, pointb, col)
	if ( tonumber(pointa[4]) == 0 ) then
		if ( not pointa[3] and pointb ) then
			local T = tremove(rec.free) or rec.drawLayer:CreateTexture();
			T:SetTexture([[Interface\AddOns\Doodlepad\line]]);
			pointa[3] = T; tinsert(rec.texs, T);
			Doodle_DrawLine(rec, T, pointb[1], pointb[2], pointa[1], pointa[2], col);
		end
	else
		local x,y = pointa[1], pointa[2];
		x,y = x * (rec.width/dw), y * (rec.height/dh);
		local T = tremove(rec.free) or rec.drawLayer:CreateTexture("OVERLAY", 7);
		T:SetTexture([[Interface\TARGETINGFRAME\UI-RaidTargetingIcon_]] .. pointa[4] or 1);
		T:SetWidth(32);T:SetHeight(32);T:SetPoint("TOPLEFT", x-16, -y+16);
		tinsert(rec.texs, T); pointa[3] = T;
		T:Show();
	end
end

function Doodle_Draw(rec, wipe, col)
	if ( wipe == true ) then
		for n = 1, #rec.texs do
			local T = tremove(rec.texs);
			T:Hide();
			T:SetTexCoord(0,1,0,1);
			tinsert(rec.free, T);
		end
		texs = {};
	else
		for n = 1, #rec.cdoodle do Doodle_Draw_Point(rec, rec.cdoodle[n], rec.cdoodle[n-1], col); end
	end
end

function Doodle_Redraw(rec)
	Doodle_Draw(rec, true)
	for n = 1, #rec.doodles do
		local doodle = rec.doodles[n];
		local col = doodle.color or colors[5];
		for n = 1, #doodle do doodle[n][3] = nil; Doodle_Draw_Point(rec, doodle[n], doodle[n-1], col); end
	end
	local doodle = rec.cdoodle;
	local col = doodle.color or colors[5];
	for n = 1, #doodle do doodle[n][3] = nil; Doodle_Draw_Point(rec, doodle[n], doodle[n-1], col); end
end

function Doodlepad_CleanUp()
	for n = 1, #Doodlepad do
		local doodle = Doodlepad[n]["doodle"];
		for i = 1, #doodle do
			local cdoodle = doodle[i];
			if ( type(cdoodle) ~= "table" ) then
				doodle[i] = nil;
			else
				for j = 1, #cdoodle do
					if ( type(cdoodle[j]) == "table" ) then
						cdoodle[j][3] = nil;
						cdoodle[j][1] = math.floor(tonumber(cdoodle[j][1]) or 0);
						cdoodle[j][2] = math.floor(tonumber(cdoodle[j][2]) or 0);
					else
						cdoodle[j] = nil;
					end
				end
			end
		end
	end
end

do
doodle.drawLayer:Hide();
doodle.height = UIParent:GetHeight();
doodle.width = UIParent:GetWidth();
	_G.SLASH_DOODLE1 = '/Doodlepad';
    _G.SLASH_DOODLEFULL1 = '/doodlefull';
	SlashCmdList['DOODLE'] = Doodlepad_window;
	SlashCmdList['DOODLEFULL'] = function()
		if ( doodle.drawLayer:IsVisible() ) then
			doodle.drawLayer:Hide()
		else
			if ( nodoodling == true ) then
				doodle.doodles, doodle.cdoodle, doodle.texs, doodle.free, doodle.icon = {},{},{},{}, 1;
				print("You are now in doodle mode. Use right click to wipe the screen and double right click to exit doodle mode.");
				nodoodling = false;
			doodle:StartCapture({
				startButton		= "LeftButtonDown",
				stopButton		= "LeftButtonUp",
				cancelButton    = "RightButtonUp",
				startFunc 		= Doodle_Color,
				updateFunc		= Doodle_Update,
				stopFunc 		= Doodle_Stop,
				cancelFunc		= Doodle_Cancel,
			});
			end
			doodle.drawLayer:Show();
		end
	end
	local frame = CreateFrame("Frame");
	frame:SetParent(UIParent);frame:SetPoint("TOPLEFT");
	frame:RegisterEvent("CHAT_MSG_ADDON");
	frame:RegisterEvent("PLAYER_LOGOUT");
	frame:SetScript("OnEvent", function(caller, event, ...) if ( event == "CHAT_MSG_ADDON" ) then Doodlepad_Incoming(...) else Doodlepad_CleanUp() end end);
	doodle.itemref = _G.SetItemRef;
	_G.SetItemRef = Doodle_ParseLink;
end
